//Arc.D
//Copyright 1993 Foresight Resources Corp.
//Author,  Mr. Randy Arms
//Draws an arc by prompting you for distance and
//radius.  Entering a negative number will reverse the arc.


XY	Pt1, Pt2;
XY	Temp;
XY	Center;
SCALAR	nRadius;
LENGTH	nDist;
ANGLE	Delta;

if(!(GetUser("scalar", "Enter Radius:\n(uses current units)", &nRadius)))
	Exit(%abort, "User Cancel");

if(!(GetUser("xy", "Enter Point 1", &Pt1)))
	Exit(%abort, "User Cancel");

if(!(GetUser("xy", "Enter Point 2", &Pt2)))
	Exit(%abort, "User Cancel");

if (nRadius < 0.0)
{
	nRadius = -nRadius;
	Temp = Pt1;
	Pt1 = Pt2;
	Pt2 = Temp;
}

if (nRadius == 0.0)
	Display("message", "error", "Cannot enter 0 radius arc!!!");

nDist = Calc("length", Pt1, Pt2);
if (nDist == 0)
	Display("message", "error", "Cannot enter 0 delta arc!!!");

Delta = asin((nDist / 2.0) / nRadius) * 2.0;
Theta = Calc("angle", Pt1, Pt2) +90 - (Delta / 2.0);

Center.x = Pt1.x + (cos(Theta) * nRadius);
Center.y = Pt1.y + (sin(Theta) * nRadius);


AddEntity("arc", Center, nRadius, Calc("angle", Center, Pt1), Delta);